/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "igniteui-react-core/ES2015/type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
export class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    hj() {
        super.hj();
        this.xAxis = null;
        this.yAxis = null;
    }
    ah(a) {
        let b = this.aj(this.mu(), this.mv.f, this.nv(this.bi), this.nw(this.bi), this.lc(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.mu(), this.mv.f, this.nv(this.bi), this.nw(this.bi), this.lc(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c2() {
        return true;
    }
    get c2() {
        return this.get_c2();
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    e6(a, b) {
        return this.e7(a, b, this.xAxis, runOn(this, this.nt), new RangeValueList(this.highColumn, this.lowColumn));
    }
    e8(a, b) {
        return this.e9(a, b, this.xAxis, runOn(this, this.nt), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d4(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.jq;
        return this.d5(a, b, this.xAxis, d, e, f, runOn(this, this.nt));
    }
    eh(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.ej(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.nt), b, c);
    }
    ef(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.ej(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.nt), b, c);
    }
    ed(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.ej(this.highColumn, a, this.xAxis, e, f, runOn(this, this.nt), b, c);
    }
    k5(a, b, c) {
        return this.lb(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ed), (d, e) => this.e9(d, e, this.xAxis, runOn(this, this.nt), this.highColumn), (d, e) => this.e7(d, e, this.xAxis, runOn(this, this.nt), this.highColumn));
    }
    k7(a, b, c) {
        return this.lb(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ef), (d, e) => this.e9(d, e, this.xAxis, runOn(this, this.nt), this.lowColumn), (d, e) => this.e7(d, e, this.xAxis, runOn(this, this.nt), this.lowColumn));
    }
    k9(a, b, c) {
        return this.lb(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    }
    np() {
        return this.yAxis != null && this.yAxis.ck();
    }
    io(a, b, c, d) {
        super.io(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hp(typeCast(Axis.$, c));
                this.it(typeCast(Axis.$, d));
                this.m3.cl.g(this.eo);
                this.i1(false);
                this.h8();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hp(typeCast(Axis.$, c));
                this.it(typeCast(Axis.$, d));
                this.m3.cl.g(this.eo);
                this.np();
                this.i1(false);
                this.h8();
                break;
        }
    }
    o3(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    o2(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.nq;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::o6', [CategoryAxisBase.$, null], 'YAxis::o7', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
